import Vue from "vue";

export default class {
  execute(spec, component) {
    if (!spec.views.length > 1) {
      console.warn("Make sure views only have 1 child!");
    }
    // const target = component.updatables[spec.targetId];
    // if (!target) console.error("no component found :" + spec.targetId);

    const target = GLib.component.findById(spec.targetId);
    if (target) {
      Object.assign(target.spec, spec.views[0]);
      this.updateComponent(target);
    }
  }

  updateComponent(component) {
    component.$ready();
    component.$forceUpdate();

    // Execute on next tick to ensure that the child has received the updated spec.
    Vue.nextTick(() => {
      component.$children.find(child => {
        this.updateComponent(child);
      });
    });
  }
}
