export default class {
  static get _registry() {
    return window.vueApp.registeredComponents;
  }
  static findById(id) {
    const component = this._registry[id];
    if (component) {
      return component;
    }
    console.error("Component not found: " + id);
  }
  static register(id, component) {
    if (this._registry[id]) {
      console.warn(
        "Duplicate component ID:",
        id,
        "Existing:",
        this.vueName(this._registry[id]),
        "New:",
        this.vueName(component)
      );
    }
    this._registry[id] = component;
  }
  static vueName(component) {
    return component.$options._componentTag;
  }
}
